// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::translate::*;
use glib::value::FromValue;
use glib::value::ToValue;
use glib::StaticType;
use glib::Type;
use std::fmt;

#[derive(Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Clone, Copy)]
#[non_exhaustive]
#[doc(alias = "ManetteEventType")]
pub enum EventType {
    #[doc(alias = "MANETTE_EVENT_NOTHING")]
    EventNothing,
    #[doc(alias = "MANETTE_EVENT_BUTTON_PRESS")]
    EventButtonPress,
    #[doc(alias = "MANETTE_EVENT_BUTTON_RELEASE")]
    EventButtonRelease,
    #[doc(alias = "MANETTE_EVENT_ABSOLUTE")]
    EventAbsolute,
    #[doc(alias = "MANETTE_EVENT_HAT")]
    EventHat,
    #[doc(hidden)]
    __Unknown(i32),
}

impl fmt::Display for EventType {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(
            f,
            "EventType::{}",
            match *self {
                Self::EventNothing => "EventNothing",
                Self::EventButtonPress => "EventButtonPress",
                Self::EventButtonRelease => "EventButtonRelease",
                Self::EventAbsolute => "EventAbsolute",
                Self::EventHat => "EventHat",
                _ => "Unknown",
            }
        )
    }
}

#[doc(hidden)]
impl IntoGlib for EventType {
    type GlibType = ffi::ManetteEventType;

    fn into_glib(self) -> ffi::ManetteEventType {
        match self {
            Self::EventNothing => ffi::MANETTE_EVENT_NOTHING,
            Self::EventButtonPress => ffi::MANETTE_EVENT_BUTTON_PRESS,
            Self::EventButtonRelease => ffi::MANETTE_EVENT_BUTTON_RELEASE,
            Self::EventAbsolute => ffi::MANETTE_EVENT_ABSOLUTE,
            Self::EventHat => ffi::MANETTE_EVENT_HAT,
            Self::__Unknown(value) => value,
        }
    }
}

#[doc(hidden)]
impl FromGlib<ffi::ManetteEventType> for EventType {
    unsafe fn from_glib(value: ffi::ManetteEventType) -> Self {
        match value {
            ffi::MANETTE_EVENT_NOTHING => Self::EventNothing,
            ffi::MANETTE_EVENT_BUTTON_PRESS => Self::EventButtonPress,
            ffi::MANETTE_EVENT_BUTTON_RELEASE => Self::EventButtonRelease,
            ffi::MANETTE_EVENT_ABSOLUTE => Self::EventAbsolute,
            ffi::MANETTE_EVENT_HAT => Self::EventHat,
            value => Self::__Unknown(value),
        }
    }
}

impl StaticType for EventType {
    fn static_type() -> Type {
        unsafe { from_glib(ffi::manette_event_type_get_type()) }
    }
}

impl glib::value::ValueType for EventType {
    type Type = Self;
}

unsafe impl<'a> FromValue<'a> for EventType {
    type Checker = glib::value::GenericValueTypeChecker<Self>;

    unsafe fn from_value(value: &'a glib::Value) -> Self {
        from_glib(glib::gobject_ffi::g_value_get_enum(value.to_glib_none().0))
    }
}

impl ToValue for EventType {
    fn to_value(&self) -> glib::Value {
        let mut value = glib::Value::for_value_type::<Self>();
        unsafe {
            glib::gobject_ffi::g_value_set_enum(value.to_glib_none_mut().0, self.into_glib());
        }
        value
    }

    fn value_type(&self) -> glib::Type {
        Self::static_type()
    }
}
